package lcsb.mapviewer.services;

import lcsb.mapviewer.common.tests.TestUtils;
import lcsb.mapviewer.common.tests.UnitTestFailedWatcher;
import lcsb.mapviewer.model.map.model.Model;
import lcsb.mapviewer.model.user.User;
import lcsb.mapviewer.persist.DbUtils;
import lcsb.mapviewer.persist.dao.user.UserDao;
import lcsb.mapviewer.services.interfaces.IConfigurationService;
import lcsb.mapviewer.services.interfaces.IMinervaJobService;
import lcsb.mapviewer.services.interfaces.IProjectService;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.junit.Before;
import org.junit.Rule;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.crypto.password.PasswordEncoder;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

import java.util.HashMap;
import java.util.Map;

@ContextConfiguration(classes = SpringServiceTestConfig.class)
@RunWith(SpringJUnit4ClassRunner.class)
public abstract class ServiceTestFunctionsNoTransaction extends TestUtils {

  protected static Logger logger = LogManager.getLogger();

  private static final Map<String, Model> models = new HashMap<>();

  @Rule
  public UnitTestFailedWatcher unitTestFailedWatcher = new UnitTestFailedWatcher();

  @Autowired
  protected IConfigurationService configurationService;

  @Autowired
  protected PasswordEncoder passwordEncoder;

  @Autowired
  protected IProjectService projectService;

  @Autowired
  protected IMinervaJobService minervaJobService;

  @Autowired
  protected UserDao userDao;

  @Autowired
  protected DbUtils dbUtils;

  @Before
  public final void __setUp() throws Exception {
    minervaJobService.enableQueue(false);
    dbUtils.setAutoFlush(false);
  }

  protected User createTestUser(final String login) {
    User user = new User();
    user.setName("Jane");
    user.setSurname("Doe");
    user.setLogin(login);
    user.setCryptedPassword("***");
    return user;
  }

}
