package lcsb.mapviewer.web.api.serializer;

import java.awt.Color;
import java.io.IOException;

import com.fasterxml.jackson.core.JsonParser;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.DeserializationContext;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.databind.deser.std.StdDeserializer;
import com.fasterxml.jackson.databind.node.ObjectNode;

public class ColorDeserializer extends StdDeserializer<Color> {

  public ColorDeserializer() {
    super(Color.class);
  }

  /**
  * 
  */
  private static final long serialVersionUID = 1L;

  @Override
  public Color deserialize(final JsonParser parser, final DeserializationContext ctxt) throws IOException, JsonProcessingException {
    ObjectMapper mapper = (ObjectMapper) parser.getCodec();
    ObjectNode rootNode = mapper.readTree(parser);

    Integer alpha = rootNode.get("alpha").asInt();
    Integer rgb = rootNode.get("rgb").asInt();

    return new Color(rgb | alpha << 24);
  }
}
